<script setup lang="ts">
import { ref, reactive, onMounted } from "vue";
import axios from "axios";

import { useRoute } from "vue-router";
import http from "@/plugins/http";
import config from "@/app.config";

import { checkPermission } from "@/utils/permissions";
import { QForm, useQuasar } from "quasar";
import { useCounterMixin } from "@/stores/mixin";

import type { QTableColumn } from "quasar";
import type { RequestItemsObject } from "@/modules/04_registryPerson/interface/request/SpecialSkill";
import type { ResponseObject } from "@/modules/04_registryPerson/interface/response/SpecialSkill";
import type { ResFileData } from "@/modules/04_registryPerson/interface/index/Main";

import dialogHeader from "@/components/DialogHeader.vue";
import DialogHistory from "@/modules/04_registryPerson/components/detail/DialogHistory.vue";

const $q = useQuasar();
const route = useRoute();
const mixin = useCounterMixin();
const {
  dialogConfirm,
  showLoader,
  hideLoader,
  messageError,
  success,
  date2Thai,
  pathRegistryEmp,
  onSearchDataTable,
  dialogRemove,
} = mixin;

const id = ref<string>(route.params.id.toString()); //id profile
const profileId = ref<string>(
  route.params.id ? route.params.id.toString() : ""
);
const empType = ref<string>(pathRegistryEmp(route.name?.toString() ?? ""));

const uploadUrl = ref<string>("");
const isUpload = ref<boolean>(false);
const fileUpload = ref<File | null>(null);
const fileData = ref<ResFileData | null>(null);
const isEdit = ref<boolean>(false);
const mode = ref<string>("table"); //การแสดงของ Table card
/**
 * props
 */
const isLeave = defineModel<boolean>("isLeave", {
  required: true,
});

const baseColumns = ref<QTableColumn[]>([
  {
    name: "field",
    align: "left",
    label: "ด้าน",
    sortable: true,
    field: "field",
    headerStyle: "font-size: 14px; width: 50px;",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "detail",
    align: "left",
    label: "รายละเอียด",
    sortable: true,
    field: "detail",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "remark",
    align: "left",
    label: "หมายเหตุ",
    sortable: true,
    field: "remark",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "reference",
    align: "left",
    label: "เอกสารอ้างอิง",
    sortable: true,
    field: "reference",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdateFullName",
    align: "left",
    label: "ผู้ดำเนินการ",
    sortable: true,
    field: "lastUpdateFullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdatedAt",
    align: "left",
    label: "วันที่แก้ไข",
    sortable: true,
    field: "lastUpdatedAt",
    format: (v) => date2Thai(v, false, true),
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);
const baseVisibleColumns = ref<string[]>([
  "field",
  "detail",
  "remark",
  "reference",
  "lastUpdateFullName",
  "lastUpdatedAt",
]);

//Table
const keyword = ref<string>(""); //คำต้นหา
const rows = ref<ResponseObject[]>([]); //รายการความสามารถ
const rowsMain = ref<ResponseObject[]>([]); //รายการความสามารถ
const columns = ref<QTableColumn[]>(
  baseColumns.value.filter((e: QTableColumn) => e.name !== "lastUpdateFullName")
);
const visibleColumns = ref<string[]>(
  baseVisibleColumns.value.filter((e: string) => e !== "lastUpdateFullName")
);
const pagination = ref({
  sortBy: "lastUpdatedAt",
});

const dialog = ref<boolean>(false); //แสดง popup ข้อมูลความสามารถพิเศษ
const dialogStatus = ref<string>("create"); ////สถานะข้อมูลความสามารถพิเศษ
const editId = ref<string>(""); //idที่ต้องการแก้ไข
const historyId = ref<string>("");

const historyDialog = ref<boolean>(false); //แสดง popup รายการประวัติ
const historyColumns = ref<QTableColumn[]>(baseColumns.value);
const historyVisibleColumns = ref<string[]>(baseVisibleColumns.value);

//ฟอร์มข้อมูลความสามารถพิเศษ
const specialSkill = reactive<RequestItemsObject>({
  field: "", //ด้าน
  detail: "", //รายละเอียด
  remark: "", //หมายเหตุ
  reference: "", //เอกสารอ้างอิง
  profileId: id.value,
});

/** function ยืนยันการบันทึกข้อมูล*/
function onSubmit() {
  dialogConfirm(
    $q,
    async () => {
      showLoader();

      const url = isEdit.value
        ? config.API.profileNewAbilityByAbilityId(editId.value, empType.value)
        : config.API.profileNewAbility(empType.value);

      const method = isEdit.value ? http.patch : http.post;

      const body = {
        ...specialSkill,
        dateEnd: null,
        dateStart: null,
        profileId: isEdit.value
          ? undefined
          : empType.value === ""
          ? id.value
          : undefined,
        profileEmployeeId: isEdit.value
          ? undefined
          : empType.value !== ""
          ? id.value
          : undefined,

        isUpload: !isEdit.value ? undefined : isUpload.value,
      };
      await method(url, body)
        .then(async (res) => {
          if (fileUpload.value) {
            const isId = isEdit.value ? editId.value : res.data.result;
            await uploadfile(isId);
          }
          await fetchData(id.value);
          success($q, "บันทึกข้อมูลสำเร็จ");
          closeDialog();
        })
        .catch((err) => {
          messageError($q, err);
        })
        .finally(() => {
          hideLoader();
        });
    },
    "ยืนยันการบันทึกข้อมูล",
    "ต้องการยืนยันการบันทึกข้อมูลนี้หรือไม่ ?"
  );
}

/** function เคลียร์ formData*/
function clearForm() {
  specialSkill.detail = "";
  specialSkill.field = "";
  specialSkill.reference = "";
  specialSkill.remark = "";
  isEdit.value = false;

  fileUpload.value = null;
  isUpload.value = false;
  fileData.value = null;
}

/**
 * function
 * @param row ข้อมูลความสามารถพิเศษ
 */
function editForm(row: any) {
  dialogStatus.value = "edit";
  editId.value = row.id;
  specialSkill.detail = row.detail;
  specialSkill.field = row.field;
  specialSkill.reference = row.reference;
  specialSkill.remark = row.remark;
  dialog.value = true;
  isEdit.value = true;
  isUpload.value = row.isUpload;

  if (isUpload.value) {
    onDownloadFile(row.id, false);
  }
}

/** function fetch ข้อมูลความสามรรถพิเศษ*/
async function fetchData(id: string) {
  showLoader();
  await http
    .get(config.API.profileNewAbilityByProfileId(id, empType.value))
    .then(async (res) => {
      rowsMain.value = await res.data.result;
      serchDataTable();
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * function ดู ระวัติการแก้ไขความสามรรถพิเศษ
 * @param id  ความสามรรถพิเศษ
 */
async function onOpenHistoryData(id: string) {
  historyId.value = id;
  historyDialog.value = true;
}

/** function fetch ประวัติการแก้ไขความสามรรถพิเศษ*/
async function fetchDataHistory() {
  showLoader();
  try {
    const res = await http.get(
      config.API.profileNewAbilityHisByAbilityId(historyId.value, empType.value)
    );

    const data = res.data.result;
    return data;
  } catch (err) {
    messageError($q, err);
  } finally {
    hideLoader();
  }
}

/**
 * ฟังก์ชันส้ราง Path อัปโหลดไฟล์
 * @param id
 */
async function uploadfile(id: string) {
  await http
    .post(
      config.API.subFile(
        "ทะเบียนประวัติ",
        "เอกสารความสามารถพิเศษ",
        profileId.value,
        id
      ),
      {
        replace: true,
        fileList: [
          {
            fileName: "เอกสารหลักฐาน",
          },
        ],
      }
    )
    .then(async (res) => {
      uploadUrl.value = res.data["เอกสารหลักฐาน"].uploadUrl;
      await uploadFileURL(uploadUrl.value, fileUpload.value, id);
    })
    .catch((err) => {
      messageError($q, err);
    });
}

/**
 * ฟังก์ชันอัปโหลดำไฟล์
 * @param uploadUrl Path อัปโหลดไฟล์
 * @param file ไฟล์เอกสาร
 */
async function uploadFileURL(uploadUrl: string, file: any, id: string) {
  await axios
    .put(uploadUrl, file, {
      headers: {
        "Content-Type": file.type,
      },
    })
    .then(async (res) => {
      if (res.status == 200) {
        await isUploadFn(id);
      }
      fileUpload.value = null;
    })
    .catch((err) => {
      messageError($q, err);
    });
}

async function isUploadFn(id: string) {
  await http
    .patch(config.API.profileNewAbilityByAbilityId(id, empType.value), {
      isUpload: fileUpload.value ? true : false,
    })
    .then(async () => {})
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * ฟังก์ชันโหลไฟลเอกสารหลักฐาน
 * @param id รายการที่ต้องการโหลด
 */
async function onDownloadFile(id: string, isLoad: boolean = true) {
  showLoader();
  await http
    .get(
      config.API.subFileByFileName(
        "ทะเบียนประวัติ",
        "เอกสารความสามารถพิเศษ",
        profileId.value,
        id,
        "เอกสารหลักฐาน"
      )
    )
    .then(async (res) => {
      const data = res.data;
      fileData.value = data;
      if (isLoad) {
        window.open(data.downloadUrl, "_blank");
      }
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/** function ปิด popup  ข้อมูลความสามารถพิเศษ*/
function closeDialog() {
  dialog.value = false;
  clearForm();
}

/** ฟังก์ค้นหาข้อมูลรายการความสามาพิเศษ */
function serchDataTable() {
  rows.value = onSearchDataTable(
    keyword.value,
    rowsMain.value,
    columns.value ? columns.value : []
  );
}

function handleDelete(rowId: string) {
  dialogRemove($q, async () => {
    showLoader();
    try {
      await http.patch(
        config.API.profileAbilityUpdateDelete(empType.value) + `${rowId}`
      );
      await fetchData(id.value);
      success($q, "ลบข้อมูลสำเร็จ");
    } catch (err) {
      messageError($q, err);
    } finally {
      hideLoader();
    }
  });
}

/** ทำงานเมื่อ Components ถูกเรียกใช้งาน*/
onMounted(() => {
  fetchData(id.value);
});
</script>

<template>
  <div class="row items-center q-gutter-x-sm q-pb-sm">
    <q-btn
      v-if="isLeave == false && checkPermission($route)?.attrIsUpdate"
      flat
      round
      color="primary"
      dense
      icon="add"
      @click="() => ((dialogStatus = 'create'), clearForm(), (dialog = true))"
    >
      <q-tooltip>เพิ่มข้อมูล</q-tooltip>
    </q-btn>
    <q-space />
    <q-input
      dense
      outlined
      v-model="keyword"
      label="ค้นหา"
      @keydown.enter.prevent="serchDataTable"
    >
      <template v-slot:append>
        <q-icon name="search" />
      </template>
    </q-input>

    <q-select
      v-model="visibleColumns"
      multiple
      outlined
      dense
      options-dense
      :display-value="$q.lang.table.columns"
      emit-value
      map-options
      :options="columns"
      option-value="name"
      style="min-width: 140px"
    />
    <q-btn-toggle
      v-model="mode"
      dense
      class="no-shadow toggle-borderd"
      toggle-color="grey-4"
      :options="[
        { value: 'table', slot: 'table' },
        { value: 'card', slot: 'card' },
      ]"
    >
      <template v-slot:table>
        <q-icon
          name="format_list_bulleted"
          size="24px"
          :style="{
            color: mode === 'table' ? '#787B7C' : '#C9D3DB',
          }"
        />
      </template>

      <template v-slot:card>
        <q-icon
          name="mdi-view-grid-outline"
          size="24px"
          :style="{
            color: mode === 'card' ? '#787B7C' : '#C9D3DB',
          }"
        />
      </template>
    </q-btn-toggle>
  </div>

  <d-table
    :grid="mode === 'card'"
    ref="table"
    row-key="id"
    flat
    bordered
    dense
    :columns="columns"
    :rows="rows"
    :visible-columns="visibleColumns"
    v-model:pagination="pagination"
  >
    <template v-slot:header="props">
      <q-tr :props="props">
        <q-th auto-width />
        <q-th v-for="col in props.cols" :key="col.name" :props="props">
          <span class="text-weight-medium">{{ col.label }}</span>
        </q-th>
        <q-th auto-width />
      </q-tr>
    </template>
    <template v-slot:body="props" v-if="mode === 'table'">
      <q-tr :props="props">
        <q-td auto-width>
          <q-btn
            flat
            dense
            round
            color="deep-purple"
            icon="mdi-history"
            @click="onOpenHistoryData(props.row.id)"
          >
            <q-tooltip>ประวัติแก้ไขความสามารถพิเศษ</q-tooltip>
          </q-btn>
          <q-btn
            v-if="isLeave == false && checkPermission($route)?.attrIsUpdate"
            flat
            dense
            round
            color="edit"
            icon="edit"
            @click="
              () => {
                editForm(props.row);
              }
            "
          >
            <q-tooltip>แก้ไขข้อมูล</q-tooltip>
          </q-btn>

          <q-btn
            v-if="!isLeave && checkPermission($route)?.attrIsDelete"
            color="red"
            flat
            dense
            round
            icon="delete"
            @click="handleDelete(props.row.id)"
          >
            <q-tooltip>ลบข้อมูล</q-tooltip>
          </q-btn>
        </q-td>
        <q-td
          v-for="col in props.cols"
          :key="col.id"
          :class="props.row.isEntry ? 'text-grey' : ''"
        >
          <div>{{ col.value ? col.value : "-" }}</div>
        </q-td>
        <q-td auto-width>
          <q-btn
            v-if="props.row.isUpload == true"
            color="green"
            flat
            dense
            round
            icon="mdi-file-document-outline"
            @click="onDownloadFile(props.row.id)"
          >
            <q-tooltip>ดาวน์โหลด</q-tooltip>
          </q-btn>
        </q-td>
      </q-tr>
    </template>
    <template v-slot:item="props" v-else>
      <div class="q-pa-xs col-xs-12 col-sm-4 col-md-3">
        <q-card bordered>
          <q-card-actions align="right" class="bg-grey-3">
            <q-btn
              v-if="props.row.isUpload == true"
              color="green"
              flat
              dense
              round
              icon="mdi-file-document-outline"
              @click="onDownloadFile(props.row.id)"
            >
              <q-tooltip>ดาวน์โหลด</q-tooltip>
            </q-btn>
            <q-btn
              dense
              flat
              round
              color="deep-purple"
              icon="mdi-history"
              @click="onOpenHistoryData(props.row.id)"
            >
              <q-tooltip>ประวัติแก้ไขความสามารถพิเศษ</q-tooltip>
            </q-btn>
            <q-btn
              v-if="isLeave == false && checkPermission($route)?.attrIsUpdate"
              dense
              flat
              round
              color="edit"
              icon="edit"
              size="14px"
              @click="
                () => {
                  editForm(props.row);
                }
              "
            >
              <q-tooltip>แก้ไขข้อมูล</q-tooltip>
            </q-btn>

            <q-btn
              v-if="!isLeave && checkPermission($route)?.attrIsDelete"
              color="red"
              flat
              dense
              round
              icon="delete"
              @click="handleDelete(props.row.id)"
            >
              <q-tooltip>ลบข้อมูล</q-tooltip>
            </q-btn>
          </q-card-actions>
          <q-separator />
          <q-list>
            <div
              :class="`row q-pa-sm`"
              :style="`background-color: ${index % 2 !== 0 ? '#FAFAFA' : ''}`"
              v-for="(col, index) in props.cols"
              :key="col.name"
            >
              <div class="col text-grey-6">
                <div>{{ col.label }}</div>
              </div>
              <div class="col">
                <div>{{ col.value ? col.value : "-" }}</div>
              </div>
            </div>
          </q-list>
        </q-card>
      </div>
    </template>
  </d-table>

  <!-- แก้ไขข้อมูลความสามารถพิเศษ -->
  <q-dialog v-model="dialog" class="dialog" persistent>
    <q-card>
      <q-form @submit.prevent greedy @validation-success="onSubmit()">
        <dialog-header
          :tittle="
            dialogStatus == 'edit'
              ? 'แก้ไขข้อมูลความสามารถพิเศษ'
              : 'เพิ่มข้อมูลความสามารถพิเศษ'
          "
          :close="closeDialog"
        />
        <q-separator />
        <q-card-section>
          <div class="row col-12 q-col-gutter-x-xs q-col-gutter-y-xs">
            <div class="col-xs-6 col-sm-6 col-md-6">
              <q-input
                outlined
                class="inputgreen"
                dense
                bg-color="white"
                v-model="specialSkill.field"
                label="ด้าน"
                hide-bottom-space
                :rules="[(val:string) => !!val || `${'กรุณากรอกด้านความสามารถพิเศษ'}`]"
              />
            </div>
            <div class="col-xs-6 col-sm-6 col-md-6">
              <q-input
                outlined
                dense
                class="inputgreen"
                bg-color="white"
                v-model="specialSkill.detail"
                label="รายละเอียด"
                hide-bottom-space
                :rules="[(val:string) => !!val || `${'กรุณากรอกรายละเอียด'}`]"
              />
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
              <q-input
                class="inputgreen"
                outlined
                dense
                bg-color="white"
                v-model="specialSkill.remark"
                label="หมายเหตุ"
              />
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
              <q-input
                class="inputgreen"
                outlined
                dense
                bg-color="white"
                v-model="specialSkill.reference"
                label="เอกสารอ้างอิง"
              />
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
              <div class="row">
                <q-uploader
                  v-if="!isUpload"
                  color="gray"
                  type="file"
                  flat
                  ref="uploader"
                  class="full-width"
                  text-color="white"
                  :max-size="10000000"
                  accept=".pdf"
                  bordered
                  label="[ไฟล์ pdf ขนาดไม่เกิน 10MB]"
                  @added="(v:any) => (fileUpload = v[0])"
                >
                  <template v-slot:header="scope">
                    <div class="row no-wrap items-center q-pa-sm q-gutter-xs">
                      <q-btn
                        v-if="scope.queuedFiles.length > 0"
                        icon="clear_all"
                        @click="scope.removeQueuedFiles"
                        round
                        dense
                        flat
                      >
                        <q-tooltip>ลบทั้งหมด</q-tooltip>
                      </q-btn>
                      <q-btn
                        v-if="scope.uploadedFiles.length > 0"
                        icon="done_all"
                        @click="scope.removeUploadedFiles"
                        round
                        dense
                        flat
                      >
                        <q-tooltip>ลบไฟล์ที่อัปโหลด</q-tooltip>
                      </q-btn>
                      <q-spinner
                        v-if="scope.isUploading"
                        class="q-uploader__spinner"
                      />
                      <div class="col">
                        <div class="q-uploader__title">
                          {{ "[ไฟล์ .pdf ขนาดไม่เกิน 10MB]" }}
                        </div>
                        <div class="q-uploader__subtitle">
                          {{ scope.uploadSizeLabel }} /
                          {{ scope.uploadProgressLabel }}
                        </div>
                      </div>
                      <q-btn
                        v-if="scope.canAddFiles"
                        type="a"
                        icon="add_box"
                        @click="scope.pickFiles"
                        round
                        dense
                        flat
                      >
                        <q-uploader-add-trigger />
                        <q-tooltip>เลือกไฟล์</q-tooltip>
                      </q-btn>
                      <q-btn
                        v-if="scope.isUploading"
                        icon="clear"
                        @click="scope.abort"
                        round
                        dense
                        flat
                      >
                        <q-tooltip>ยกเลิกการอัปโหลด</q-tooltip>
                      </q-btn>
                    </div>
                  </template>
                </q-uploader>

                <q-list bordered dense separator v-else class="full-width">
                  <q-item>
                    <q-item-section> {{ fileData?.fileName }}</q-item-section>
                    <q-item-section avatar>
                      <div class="row">
                        <q-btn
                          flat
                          round
                          color="primary"
                          icon="mdi-download"
                          @click="onDownloadFile(editId)"
                        />

                        <q-btn
                          flat
                          round
                          color="grey"
                          icon="close"
                          @click="isUpload = false"
                        />
                      </div>
                    </q-item-section>
                  </q-item>
                </q-list>
              </div>
            </div>
          </div>
        </q-card-section>

        <q-separator />

        <q-card-actions align="right">
          <q-btn label="บันทึก" id="onSubmit" type="submit" color="public">
            <q-tooltip>บันทึกข้อมูล</q-tooltip>
          </q-btn>
        </q-card-actions>
      </q-form>
    </q-card>
  </q-dialog>

  <!-- ประวัติแก้ไขความสามารถพิเศษ -->
  <DialogHistory
    v-model:modal="historyDialog"
    :columns="historyColumns"
    :visible-columns="historyVisibleColumns"
    :title="`ประวัติแก้ไขความสามารถพิเศษ`"
    :fetch-data="fetchDataHistory"
  />
</template>

<style scoped>
.bg-color {
  background-color: #fafafa;
}
</style>
